const getters = {
  getSubscriptionsGroupedByType (state) {
    let subscriptions = {
      'random': [],
      'student': [],
      'exam': [],
      'submission_type': []
    }
    Object.entries(state.subscriptions).forEach(([id, subscription]) => {
      subscriptions[subscription.query_type].push(subscription)
    })
    // sort the resulting arrays in subscriptions lexicographically by their query_keys
    Object.entries(subscriptions).forEach(([id, arr]) => {
      if (arr.length > 1 && arr[0].hasOwnProperty('query_key')) {
        arr.sort((a, b) => {
          const aLower = a['query_key'].toLowerCase()
          const bLower = b['query_key'].toLowerCase()
          if (aLower < bLower) {
            return -1
          } else if (aLower > bLower) {
            return 1
          } else {
            return 0
          }
        })
      }
    })
    return subscriptions
  },
  getSubmission: state => pk => {
    return state.submissions[pk]
  },
  getFeedback: state => pk => {
    return state.feedback[pk]
  },
  getSubmissionType: state => pk => {
    return state.submissionTypes[pk]
  }
}

export default getters
